import * as react_jsx_runtime from 'react/jsx-runtime';
import { NFTCollectionViewProps, NFTDetailProps, Crossmint, createCrossmint, UIConfig } from '@crossmint/common-sdk-base';
import { CrossmintEmbeddedCheckoutProps, CrossmintPayButtonProps } from '@crossmint/client-sdk-base';
export { CrossmintEvent, CrossmintEventMap, CrossmintEvents, useCrossmintEvents } from '@crossmint/client-sdk-base';
import * as react from 'react';
import { MouseEvent, CSSProperties, ReactNode } from 'react';
import * as _crossmint_client_sdk_smart_wallet from '@crossmint/client-sdk-smart-wallet';
import { EVMSmartWallet, SmartWalletError, WalletParams, EVMSmartWalletChain } from '@crossmint/client-sdk-smart-wallet';
export { AdminAlreadyUsedError, AdminMismatchError, Chain, ConfigError, EVMSendTransactionError, EVMSendTransactionExecutionRevertedError, EVMSmartWallet, PasskeyIncompatibleAuthenticatorError, PasskeyMismatchError, PasskeyPromptError, PasskeyRegistrationError, SmartWalletError, SmartWalletsNotEnabledError, UserWalletAlreadyCreatedError } from '@crossmint/client-sdk-smart-wallet';

declare function CrossmintNFTCollectionView(props: NFTCollectionViewProps): react_jsx_runtime.JSX.Element;

declare function CrossmintNFTDetail(props: NFTDetailProps): react_jsx_runtime.JSX.Element;

declare function CrossmintPaymentElement(props: CrossmintEmbeddedCheckoutProps): react_jsx_runtime.JSX.Element;

type CrossmintPayButtonReactProps = CrossmintPayButtonProps & {
    onClick?: (e: MouseEvent<HTMLButtonElement>) => void;
    style?: CSSProperties;
};
declare function CrossmintPayButton(buttonProps: CrossmintPayButtonReactProps): react_jsx_runtime.JSX.Element;

interface CrossmintContext {
    crossmint: Crossmint;
    setJwt: (jwt: string | undefined) => void;
}
declare function CrossmintProvider({ children, ...createCrossmintParams }: {
    children: ReactNode;
} & Parameters<typeof createCrossmint>[0]): react_jsx_runtime.JSX.Element;
declare function useCrossmint(missingContextMessage?: string): CrossmintContext;

type WalletStatus = "not-loaded" | "in-progress" | "loaded" | "loading-error";
type WalletContext = {
    status: WalletStatus;
    wallet?: EVMSmartWallet;
    error?: SmartWalletError;
    getOrCreateWallet: (config?: WalletConfig) => {
        startedCreation: boolean;
        reason?: string;
    };
    clearWallet: () => void;
};
declare const WalletContext: react.Context<WalletContext>;
type WalletConfig = WalletParams & {
    type: "evm-smart-wallet";
};
declare function CrossmintWalletProvider({ children, defaultChain, }: {
    children: ReactNode;
    defaultChain: EVMSmartWalletChain;
}): react_jsx_runtime.JSX.Element;

declare function useWallet(): {
    status: "not-loaded" | "in-progress" | "loaded" | "loading-error";
    wallet?: _crossmint_client_sdk_smart_wallet.EVMSmartWallet;
    error?: _crossmint_client_sdk_smart_wallet.SmartWalletError;
    getOrCreateWallet: (config?: WalletConfig) => {
        startedCreation: boolean;
        reason?: string;
    };
    clearWallet: () => void;
};

declare function useAuth(): {
    login: () => void;
    logout: () => void;
    jwt?: string;
    status: "in-progress" | "logged-in" | "logged-out";
};

type CrossmintAuthWalletConfig = {
    defaultChain: EVMSmartWalletChain;
    createOnLogin: "all-users" | "off";
    type: "evm-smart-wallet";
};
type CrossmintAuthProviderProps = {
    embeddedWallets: CrossmintAuthWalletConfig;
    appearance?: UIConfig;
    children: ReactNode;
};
type AuthStatus = "logged-in" | "logged-out" | "in-progress";
type AuthContextType = {
    login: () => void;
    logout: () => void;
    jwt?: string;
    status: AuthStatus;
};
declare const AuthContext: react.Context<AuthContextType>;
declare function CrossmintAuthProvider({ embeddedWallets, children, appearance }: CrossmintAuthProviderProps): react_jsx_runtime.JSX.Element;

export { AuthContext, CrossmintAuthProvider, type CrossmintAuthProviderProps, type CrossmintAuthWalletConfig, type CrossmintContext, CrossmintNFTCollectionView, CrossmintNFTDetail, CrossmintPayButton, type CrossmintPayButtonReactProps, CrossmintPaymentElement, CrossmintProvider, CrossmintWalletProvider, type WalletConfig, WalletContext, useAuth, useCrossmint, useWallet };
